#include "RaveBase/Converters/interface/TrackToFTSStore.h"
#include <iostream>

using namespace std;

void TrackToFTSStore::clear()
{
  association_.clear();
  bassociation_.clear();
}

TrackToFTSStore & TrackToFTSStore::Instance()
{
  static TrackToFTSStore singleton;
  return singleton;
}

void TrackToFTSStore::associate ( const rave::Track & t,
                                  const FreeTrajectoryState & fts )
{
  /* cout << "[TrackToFTSStore] we associate, yeah! " << t.id() 
       << " with " << fts.momentum() << endl; */
  association_[t.id()]=fts;
  bassociation_[fts]=t.id();
}

int TrackToFTSStore::getId ( const FreeTrajectoryState & fts ) const
{
  if ( bassociation_.count ( fts ) == 0 )
    return -1;
  return bassociation_[fts];
}

bool TrackToFTSStore::has ( const FreeTrajectoryState & fts ) const
{
  bool ret = ( bassociation_.count ( fts ) > 0 );
  /*
  cout << "[TrackToFTSStore] do we have " << fts.momentum() << ": "
       << ret << endl;
       */
  return ret;
}

const FreeTrajectoryState & TrackToFTSStore::getFts ( const rave::Track & t ) const
{
  if ( association_.count ( t.id() ) == 0 )
  {
    return FreeTrajectoryState();
  }
  return association_[t.id()];
}

